import sys, java, time
global AdminApp
global AdminConfig

def startApplication(): 
  nodeName = AdminControl.getNode()
  appManager = AdminControl.queryNames('type=ApplicationManager,node='+nodeName+',*')
  print 'Wait for 2 minutes to ensure application is available before starting it'
  time.sleep(120)
  print 'Starting the Application: ' + appName 
  print '--------------'
  print 'AppManager: ' + appManager
  print '--------------'
  AdminControl.invoke(appManager, 'startApplication', appName)
  if (len(AdminControl.completeObjectName('type=Application,name=' + appName + ',*')) > 0):
    print 'INFO: the application started successfully'
  else:
    print 'ERROR: the application did not start'
#endDef 


appLocation = sys.argv[0]
appName = sys.argv[1]

if len(sys.argv) > 2 :
  contextRoot = sys.argv[2] 
else:
  contextRoot = 'ram.setup'

foundApp = 'false'
for app in AdminApp.list().split():
  if app == appName:
    foundApp = 'true'

if foundApp == 'true':
  print 'The Application ' + appName + ' is deployed'
  print 'Uninstalling previous application ' + appName
  AdminApp.uninstall(appName)
  AdminConfig.save()
  print 'Installing ' + appName
  appArgs = ' -usedefaultbindings -MapWebModToVH [[com.ibm.ram.repository.setup.web com.ibm.ram.repository.setup.web.war,WEB-INF/web.xml admin_host]]' + ' -CtxRootForWebMod [[.* com.ibm.ram.repository.setup.web.war,WEB-INF/web.xml /' + contextRoot + ']]'
  AdminApp.install(appLocation, appArgs)
  AdminConfig.save()
  startApplication()
if foundApp == 'false':
  print 'The Application ' + appName + ' is not deployed'
  print 'Installing ' + appName
  appArgs = ' -usedefaultbindings -MapWebModToVH [[com.ibm.ram.repository.setup.web com.ibm.ram.repository.setup.web.war,WEB-INF/web.xml admin_host]]' + ' -CtxRootForWebMod [[.* com.ibm.ram.repository.setup.web.war,WEB-INF/web.xml /' + contextRoot + ']]'
  AdminApp.install(appLocation, appArgs)
  AdminConfig.save()
  startApplication()
    


